package cn.com.ty.lift.ud.schoolVideo.service.impl;

import java.util.List;

import cn.com.ty.lift.ud.dataBank.mapper.LiftBrandMapper;
import cn.com.ty.lift.ud.dataBank.mapper.entity.LiftBrandEntity;
import cn.com.ty.lift.ud.schoolVideo.controller.query.SchoolVideoQuery;
import cn.com.ty.lift.ud.schoolVideo.mapper.SchoolVideoMapper;
import cn.com.ty.lift.ud.schoolVideo.mapper.entity.SchoolVideoEntity;
import cn.com.xwy.util.collection.ListUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import cn.com.ty.lift.ud.schoolVideo.service.ISchoolVideoService;
import cn.com.xwy.boot.web.dto.RestResponse;

/**
 * 电梯学堂 -ServiceImpl
 *
 * @author Xson
 * @date 2020-04-23
 */
@Service
@Transactional
public class SchoolVideoServiceImpl extends ServiceImpl<SchoolVideoMapper, SchoolVideoEntity>
    implements ISchoolVideoService {

    private @Autowired SchoolVideoMapper schoolVideoMapper;
    private @Autowired LiftBrandMapper liftBrandMapper;

    @Override
    public void updateByIds(List<Long> ids, Integer status) {
        for (Long id : ids) {
            SchoolVideoEntity bit = new SchoolVideoEntity();
            bit.setId(id);
            bit.setStatuz(status);
            schoolVideoMapper.updateById(bit);
        }
    }

    @Override
    public RestResponse examineById(SchoolVideoEntity neDto) {
        if (neDto.getCheckFlag() == 1) {
            schoolVideoMapper.examineById(neDto.getId());
            return RestResponse.success("审批通过");
        } else {
            // 修改状态为 驳回，并加上驳回理由
            schoolVideoMapper.updateInfoById(neDto.getId(), neDto.getCheckComment());
            // todo 发送消息给该用户
            return RestResponse.fail("审批驳回");
        }
    }

    @Override
    public void updateHotFlagByIds(List<Long> ids, Integer status) {
        for (Long id : ids) {
            SchoolVideoEntity bit = new SchoolVideoEntity();
            bit.setId(id);
            bit.setHotFlag(status);
            schoolVideoMapper.updateById(bit);
        }
    }

    @Override
    public void updateBrowseNum(Long id) {
        schoolVideoMapper.updateBrowseNum(id);
    }

    @Override
    public RestResponse selectByExample(SchoolVideoQuery query) {
        IPage page = query.page();
        List<SchoolVideoEntity> list = schoolVideoMapper.selectByQuery(query.condition(), query);
        if (ListUtil.isNotEmpty(list)) {
            for (SchoolVideoEntity st : list) {
                LiftBrandEntity byId = liftBrandMapper.selectById(st.getBrandId());
                if (byId != null) {
                    st.setBrandName(byId.getName());
                }
            }
        }
        int total = schoolVideoMapper.countByQuery(query.condition());
        page.setRecords(list);
        page.setTotal(total);
        return RestResponse.success(page, "Queried successfully");
    }

    @Override
    public void updateReward(Long id) {
        schoolVideoMapper.updateReward(id);
    }

}
